/***************************************************************************
                 base.h  -  Base defines for ABT room library
                             -------------------
    begin                : Tue Jul 8 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoABT, base.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#ifndef __NEOABT_BASE_H
#define __NEOABT_BASE_H

#include <neoengine/base.h>

#define NEOABTVERSION_MAJOR             NEOENGINEVERSION_MAJOR
#define NEOABTVERSION_MINOR             NEOENGINEVERSION_MINOR
#define NEOABTVERSION_REVISION          NEOENGINEVERSION_REVISION

#define NEOABTVERSIONSTRING             NEOENGINEVERSIONSTRING


#ifdef WIN32

#  ifdef _MSC_VER
#    pragma warning( disable : 4231 )
#  endif

#  ifdef BUILD_STATIC

#    define NEOABT_API
#    define NEOABTEXPIMP_TEMPLATE

#  else

#    ifdef NEOABT_EXPORTS

#      define NEOABT_API __declspec(dllexport)
#      define NEOABTEXPIMP_TEMPLATE

#    else

#      define NEOABT_API __declspec(dllimport)
#      define NEOABTEXPIMP_TEMPLATE extern

#    endif

#  endif

#  ifdef __cplusplus
	// Instantiate class std::vector<classname> and std::list<classname>
	// This does not create an object. It only forces the generation of all
	// of the members of the class.
	// It exports them from the DLL and imports them into the .exe file.
#    ifdef BUILD_STATIC
#      define ABTUDTVectorEXPIMP(classname)
#    else
#      if ( _MSC_VER >= 1300 )
#        define ABTUDTVectorEXPIMP(classname) NEOABTEXPIMP_TEMPLATE template class NEOABT_API std::allocator< classname >; NEOABTEXPIMP_TEMPLATE template class NEOABT_API std::vector< classname >
#      elif !defined( __MINGW32__ )
#        define ABTUDTVectorEXPIMP(classname) NEOABTEXPIMP_TEMPLATE template class NEOABT_API std::vector< classname >
#      else
#        define ABTUDTVectorEXPIMP(classname)
#      endif
#    endif
#  endif

#elif defined(POSIX) || defined(__APPLE__)

#  define NEOABT_API
#  define NEOABT_TEMPLATE

#  define ABTUDTVectorEXPIMP(classname)

#else
#  error "Platform uninplemented"
#endif

#endif
