/***************************************************************************
                 base.h  -  Base defines for BSP room library
                             -------------------
    begin                : Mon Jul 28 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoBSP, base.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#ifndef __NEOBSP_BASE_H
#define __NEOBSP_BASE_H

#include <neoengine/base.h>

#define NEOBSPVERSION_MAJOR             NEOENGINEVERSION_MAJOR
#define NEOBSPVERSION_MINOR             NEOENGINEVERSION_MINOR
#define NEOBSPVERSION_REVISION          NEOENGINEVERSION_REVISION

#define NEOBSPVERSIONSTRING             NEOENGINEVERSIONSTRING


#ifdef WIN32

#  ifdef _MSC_VER
#    pragma warning( disable : 4231 )
#  endif

#  ifdef BUILD_STATIC

#    define NEOBSP_API
#    define NEOBSPEXPIMP_TEMPLATE

#  else

#    ifdef NEOBSP_EXPORTS

#      define NEOBSP_API __declspec(dllexport)
#      define NEOBSPEXPIMP_TEMPLATE

#    else

#      define NEOBSP_API __declspec(dllimport)
#      define NEOBSPEXPIMP_TEMPLATE extern

#    endif
#  endif

#  ifdef __cplusplus
	// Instantiate class std::vector<classname> and std::list<classname>
	// This does not create an object. It only forces the generation of all
	// of the members of the class.
	// It exports them from the DLL and imports them into the .exe file.
#    ifdef BUILD_STATIC
#      define BSPUDTVectorEXPIMP(classname)
#    else
#      if ( _MSC_VER >= 1300 )
#        define BSPUDTVectorEXPIMP(classname) NEOBSPEXPIMP_TEMPLATE template class NEOBSP_API std::allocator< classname >; NEOBSPEXPIMP_TEMPLATE template class NEOBSP_API std::vector< classname >
#      elif !defined( __MINGW32__ )
#        define BSPUDTVectorEXPIMP(classname) NEOBSPEXPIMP_TEMPLATE template class NEOBSP_API std::vector< classname >
#      else
#        define BSPUDTVectorEXPIMP(classname)
#      endif
#    endif
#  endif

#elif defined(POSIX) || defined(__APPLE__)

#  define NEOBSP_API
#  define NEOBSP_TEMPLATE

#  define BSPUDTVectorEXPIMP(classname)

#else
#  error "Platform uninplemented"
#endif


namespace NeoBSP
{

#ifndef BUILD_STATIC

extern "C"
{

#endif

NEOBSP_API int Initialize();

NEOBSP_API int Shutdown();

#ifndef BUILD_STATIC

}

#endif

};


#endif
