/***************************************************************************
                       complex.cpp  -  Complex chunks
                             -------------------
    begin                : Tue Feb 18 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoChunkIO, complex.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "complex.h"


using namespace std;

namespace NeoChunkIO
{



int ComplexChunk::GetSize( bool bIncludeHeader ) const
{
	//Binary mode only
	int iSize = 0;

	if( bIncludeHeader )
	{
		iSize += 2; //Type
		iSize += (int)m_strID.length() + 1;

		iSize += 4; //Chunk size
	}

	iSize += 2; //The short holding chunk version number
	iSize += 2; //The short holding number of subchunks

	vector< Chunk* >::const_iterator ppkChunk = m_vpkSubChunks.begin();
	vector< Chunk* >::const_iterator ppkEnd   = m_vpkSubChunks.end();
	
	for( ; ppkChunk != ppkEnd; ++ppkChunk )
		iSize += (*ppkChunk)->GetSize( true );

	return iSize;
}


}; // namespace NeoChunkIO



