/***************************************************************************
                     matrix.cpp  -  Matrix primitive chunk
                             -------------------
    begin                : Wed Feb 26 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoChunkIO, matrix.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "matrix.h"

#include <neoengine/file.h>

using namespace NeoEngine;

namespace NeoChunkIO
{


int MatrixChunk::ReadData( File *pkFile, ChunkIO::CHUNKIOMODE eMode, unsigned int uiEnd )
{
	float *pfData = (float*)m_kData;

	for( int i = 0; i < 16; ++i, ++pfData )
		*pkFile >> *pfData;

	return( !*pkFile ? -1 : 64 );
}


int MatrixChunk::WriteData( File *pkFile, ChunkIO::CHUNKIOMODE eMode, unsigned int uiLevel )
{
	float *pfData = (float*)m_kData;

	if( eMode == ChunkIO::BINARY )
	{
		for( int i = 0; i < 16; ++i, ++pfData )
			*pkFile << *pfData;
	}
	else
	{
		*pkFile << *pfData++;

		for( int i = 1; i < 16; ++i, ++pfData )
			*pkFile << ' ' << *pfData;
	}

	return( !*pkFile ? -1 : 64 );
}


}; // namespace NeoChunkIO

