/***************************************************************************
                         skybox.cpp  -  Skybox chunk
                             -------------------
    begin                : Thu Feb 27 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoChunkIO, skybox.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "skybox.h"
#include "chunktype.h"
#include "material.h"

#include <neoengine/skybox.h>
#include <neoengine/logstream.h>


using namespace std;
using namespace NeoEngine;


namespace NeoChunkIO
{


int SkyBoxChunk::ParseData( unsigned int uiFlags, FileManager *pkFileManager )
{
	SkyBox *pkBox = new SkyBox;

	m_pkEntity = pkBox;

	vector<Chunk*> vpkMatChunks;

	FindChunks( "", ChunkType::MATERIAL, &vpkMatChunks, false );

	if( vpkMatChunks.size() != SkyBox::NUMPLANES )
		neolog << LogLevel( WARNING ) << "*** Invalid skybox chunk: material subchunk count mismatch" << endl;
	else for( unsigned int i = 0; i < SkyBox::NUMPLANES; ++i )
		pkBox->SetMaterial( (SkyBox::SKYBOXPLANE)i, dynamic_cast< MaterialChunk* >( vpkMatChunks[i] )->m_pkMaterial );

	//Make us findable by scene entity type
	m_usFindType = ChunkType::SCENEENTITY;

	return 1;
}



}; // namespace NeoChunkIO

