/***************************************************************************
             submeshkeyframe.cpp  -  Submesh animation keyframe chunk
                             -------------------
    begin                : Wed Feb 26 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoChunkIO, submeshkeyframe.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "submeshkeyframe.h"
#include "chunktype.h"
#include "float.h"
#include "vertexbuffer.h"

#include <neoengine/submeshanimator.h>
#include <neoengine/logstream.h>

using namespace std;
using namespace NeoEngine;

namespace NeoChunkIO
{

SubMeshKeyframeChunk::~SubMeshKeyframeChunk()
{
	delete m_pkKeyframe;
}


int SubMeshKeyframeChunk::ParseData( unsigned int uiFlags, FileManager *pkFileManager )
{
	m_pkKeyframe = new SubMeshKeyframe;

	Chunk *pkChunk;

	if( !( pkChunk = FindChunk( "time", ChunkType::FLOAT, -1 ) ) )
		neolog << LogLevel( WARNING ) << "*** Invalid submesh keyframe chunk: no timestamp subchunk" << endl;
	else
		m_pkKeyframe->m_fT = dynamic_cast< FloatChunk* >( pkChunk )->m_fData;

	if( !( pkChunk = FindChunk( "target", ChunkType::VERTEXBUFFER, -1 ) ) )
		neolog << LogLevel( ERROR ) << "*** Invalid submesh keyframe chunk: no vertexbuffer subchunk" << endl;
	else
		m_pkKeyframe->m_pkBuffer = dynamic_cast< VertexBufferChunk* >( pkChunk )->m_pkBuffer;

	return 1;
}


}; // namespace NeoChunkIO


