/***************************************************************************
                    device.cpp  -  aRts sound device
                             -------------------
    begin                : Sun Jun 06 2004
    copyright            : (C) 2004 by Adam Butcher
    email                : adam.j.butcher@virgin.net
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevALSA, device.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2004
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "device.h"

#include <neoengine/core.h>
#include <neoengine/logstream.h>

#include <artsc.h>
#include <pthread.h>

using namespace NeoEngine;
using namespace std;


namespace NeoArts
{


AudioDevice::AudioDevice( FileManager *pkFileManager ) :
	NeoEngine::AudioDevice( pkFileManager )
{
	m_bInitialized = false;
}


AudioDevice::~AudioDevice()
{
}


bool AudioDevice::Open( const RenderWindow &rkWindow )
{
	Close();

	pthread_mutex_init( &m_kMutex, 0 );
	
	if( ! m_bInitialized )
		m_bInitialized = arts_init() == 0;

	return m_bInitialized;
}


void AudioDevice::Close()
{
	pthread_mutex_destroy( &m_kMutex );
	
	if( m_bInitialized )
		arts_free();
}


};

