/***************************************************************************
                       clear.cpp  -  Clear back buffer
                             -------------------
    begin                : Mon Mar 10 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevD3D9, clear.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 Contributors: Keaton Mullis (kmullis@zianet.com)

 ***************************************************************************/

#include "device.h"

using namespace NeoEngine;


namespace NeoD3D9
{


void Device::Clear( unsigned int uiTargets, const Color &rkColor, float fZValue, unsigned int uiStencilValue )
{
	unsigned int uiBits = 0;

	if( uiTargets & COLORBUFFER )
		uiBits |= D3DCLEAR_TARGET;

	if( uiTargets & ZBUFFER )
		uiBits |= D3DCLEAR_ZBUFFER;

	if( ( uiTargets & STENCILBUFFER ) && m_kWindow.m_kCaps.IsSet( RenderCaps::STENCILBUFFER ) )
		uiBits |= D3DCLEAR_STENCIL;
	
	m_pkDevice->Clear( 0, 0, uiBits, D3DCOLOR_COLORVALUE(rkColor.r, rkColor.g, rkColor.b, rkColor.a), fZValue, uiStencilValue);
}


};

