/***************************************************************************
                          mouse.cpp  -  Mouse methods
                             -------------------
    begin                : Thu Mar 20 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevD3D9, mouse.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "device.h"


namespace NeoD3D9
{


void Device::SetMousePos( int iX, int iY )
{
	if( !m_kWindow.m_hWnd )
		return;

	if( iX < 0 )
		iX = 0;
	else if( iX >= (int)m_kWindow.m_kResolution.m_uiWidth )
		iX = m_kWindow.m_kResolution.m_uiWidth - 1;

	if( iY < 0 )
		iY = 0;
	else if( iY >= (int)m_kWindow.m_kResolution.m_uiHeight )
		iY = m_kWindow.m_kResolution.m_uiHeight - 1;


	POINT pt;

	pt.x = iX;
	pt.y = iY;

	ClientToScreen( (HWND)m_kWindow.m_hWnd, &pt );

	SetCursorPos( pt.x, pt.y );
}


void Device::CaptureMouse( bool bCapture )
{
	if( !m_kWindow.m_hWnd )
		return;

	if( bCapture )
	{
		POINT pt;

		pt.x = 0;
		pt.y = 0;

		ClientToScreen( (HWND)m_kWindow.m_hWnd, &pt );

		RECT kRect;

		kRect.top    = pt.x;
		kRect.bottom = kRect.top  + m_kWindow.m_kResolution.m_uiHeight;
		kRect.left   = pt.y;
		kRect.right  = kRect.left + m_kWindow.m_kResolution.m_uiWidth;

		ClipCursor( &kRect );
	}
	else
		ClipCursor( 0 );
}


void Device::ShowCursor( bool bShow )
{
	m_bShowCursor = bShow;
	if( bShow )
		SetCursor( LoadCursor( 0, IDC_ARROW ) );
	else
		SetCursor( NULL );
	m_pkDevice->ShowCursor( bShow );
}


}; // namespace NeoD3D9
