/***************************************************************************
                     stencilbuffer.cpp  -  Stencil Buffer
                             -------------------
    begin                : Fri May 23 2003
    copyright            : (C) 2003 by Keaton Mullis
    email                : kmullis@zianet.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevD3D9, stencilbuffer.cpp

 The Initial Developer of the Original Code is Keaton Mullis.
 Portions created by Keaton Mullis are Copyright (C) 2003
 Keaton Mullis. All Rights Reserved.

 Contributors: Mattias Jansson (mattias@realityrift.com)

 ***************************************************************************/

#include "device.h"


namespace NeoD3D9
{


DWORD g_aeStencilOp[] = 
{
	D3DSTENCILOP_KEEP,
	D3DSTENCILOP_ZERO,
	D3DSTENCILOP_REPLACE,
	D3DSTENCILOP_INCR,
	D3DSTENCILOP_DECR,
	D3DSTENCILOP_INVERT
};

DWORD g_aeStencilFunc[] = 
{
	D3DCMP_NEVER,
	D3DCMP_LESS,
	D3DCMP_LESSEQUAL,
	D3DCMP_GREATER,
	D3DCMP_GREATEREQUAL,
	D3DCMP_EQUAL,
	D3DCMP_NOTEQUAL,
	D3DCMP_ALWAYS
};


void Device::SetStencilOp( STENCILOP eStencilFail, STENCILOP eZFail, STENCILOP eZPass )
{
	m_pkDevice->SetRenderState( D3DRS_STENCILFAIL,  g_aeStencilOp[ eStencilFail ] );
	m_pkDevice->SetRenderState( D3DRS_STENCILZFAIL, g_aeStencilOp[ eZFail ]       );
	m_pkDevice->SetRenderState( D3DRS_STENCILPASS,  g_aeStencilOp[ eZPass ]       );
}

void Device::SetStencilFunc( STENCILFUNC eFunc, unsigned int uiRefValue, unsigned int uiTestMask )
{
	m_pkDevice->SetRenderState( D3DRS_STENCILFUNC, g_aeStencilFunc[ eFunc ] );
	m_pkDevice->SetRenderState( D3DRS_STENCILREF,  uiRefValue               );
	m_pkDevice->SetRenderState( D3DRS_STENCILMASK, uiTestMask               );
}


void Device::SetStencilMask( unsigned int uiWriteMask )
{
	m_pkDevice->SetRenderState( D3DRS_STENCILWRITEMASK, uiWriteMask );
}


}; // namespace NeoD3D9

