/***************************************************************************
             query.cpp  -  Query device for adapters and resolutions
                             -------------------
    begin                : Tue Oct 28 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevOpenGL, query.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#define NEEDGDI

#include "device.h"

#include <algorithm>

using namespace std;
using namespace NeoEngine;


namespace NeoOGL
{


void Device::QueryAdapters( vector< RenderAdapter > *pvkAdapters )
{
}


void Device::QueryResolutions( vector< RenderResolution > *pvkResolutions, unsigned int uiAdapter )
{
	if( !pvkResolutions )
		return;

#ifdef WIN32
	int              iMode = 0;
	DEVMODE          devMode;
	RenderResolution kRes;

	while( EnumDisplaySettings( 0, iMode++, &devMode ) )
	{
		kRes.m_uiWidth       = devMode.dmPelsWidth;
		kRes.m_uiHeight      = devMode.dmPelsHeight;
		kRes.m_uiBPP         = devMode.dmBitsPerPel;
		kRes.m_uiDepthBits   = 0;
		kRes.m_uiStencilBits = 0;
		kRes.m_uiRefreshRate = devMode.dmDisplayFrequency;

		if( kRes.m_uiBPP >= 15 )
			pvkResolutions->push_back( kRes );
	}
#endif

	sort( pvkResolutions->begin(), pvkResolutions->end() );
}


};

