/***************************************************************************
                 final.h  -  nVidia register combiners parser
                             -------------------
    begin       : Wed Jan 7 2004
    copyright   : (C) 2004 by Reality Rift Studios
    email       : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevOpenGL, rcparse/final.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2004
 Reality Rift Studios. All Rights Reserved.
 ***************************************************************************/

#ifndef _NEOGL_RCPARSE_FINAL_H
#define _NEOGL_RCPARSE_FINAL_H


#include <neoengine/base.h>

#include "register.h"


namespace NeoOGL
{


class NVFinalAlphaFunction
{
	public:

		NVMappedRegister g;

		void Init( NVMappedRegister _g )
		{ 
			g = _g;
		}

		void ZeroOut();
};


class NVFinalRgbFunction
{
	public:

		NVMappedRegister a;
		NVMappedRegister b;
		NVMappedRegister c;
		NVMappedRegister d;

		void Init( NVMappedRegister _a, NVMappedRegister _b, NVMappedRegister _c, NVMappedRegister _d )
		{
			a = _a;
			b = _b;
			c = _c;
			d = _d;
		}
	
		void ZeroOut();
};


class NVFinalProduct
{
	public:

		NVMappedRegister e;
		NVMappedRegister f;

		void Init( NVMappedRegister _e, NVMappedRegister _f )
		{ 
			e = _e;
			f = _f;
		}
	
		void ZeroOut();
};


class NVFinalCombiner
{
	public:

		int                  hasProduct;
		NVFinalProduct       product;
		int                  clamp;
		NVFinalRgbFunction   rgb;
		NVFinalAlphaFunction alpha;

		void Init( NVFinalRgbFunction _rgb, NVFinalAlphaFunction _alpha, int _clamp, NVFinalProduct _product )
		{
			rgb        = _rgb;
			alpha      = _alpha;
			clamp      = _clamp;
			product    = _product;
			hasProduct = true;
		}

		void Init( NVFinalRgbFunction _rgb, NVFinalAlphaFunction _alpha, int _clamp )
		{
			rgb        = _rgb;
			alpha      = _alpha;
			clamp      = _clamp;
			hasProduct = false;
			product.ZeroOut();
		}

		bool Validate();
	
		void Invoke();
};


};


#endif
