/***************************************************************************
                  stencilbuffer.cpp  -  Stencil buffer control
                             -------------------
    begin                : Fri May 23 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevOpenGL, stencilbuffer.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "device.h"

#include <neoengine/logstream.h>

using namespace std;
using namespace NeoEngine;


namespace NeoOGL
{


GLenum g_aeStencilOp[] =
{

	GL_KEEP,
	GL_ZERO,
	GL_REPLACE,
	GL_INCR,
	GL_DECR,
	GL_INVERT

};



GLenum g_aeStencilFunc[] =
{

	GL_NEVER,
	GL_LESS,
	GL_LEQUAL,
	GL_GREATER,
	GL_GEQUAL,
	GL_EQUAL,
	GL_NOTEQUAL,
	GL_ALWAYS

};





void Device::SetStencilOp( STENCILOP eStencilFail, STENCILOP eZFail, STENCILOP eZPass )
{
	glStencilOp( g_aeStencilOp[ eStencilFail ], g_aeStencilOp[ eZFail ], g_aeStencilOp[ eZPass ] );
}


void Device::SetStencilFunc( STENCILFUNC eFunc, unsigned int uiRefValue, unsigned int uiTestMask )
{
	glStencilFunc( g_aeStencilFunc[ eFunc ], uiRefValue, uiTestMask );
}


void Device::SetStencilMask( unsigned int uiWriteMask )
{
	glStencilMask( uiWriteMask );
}


}; // namespace NeoOGL

