/***************************************************************************
     vertexbuffermanager-nobs.cpp  -  Vertex buffer allocation manager
	               without backing storage capabilities
                             -------------------
    begin                : Sat May 10 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoDevOpenGL, vertexbuffermanager-nobs.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "vertexbuffermanager-nobs.h"
#include "vertexbuffer.h"

using namespace NeoEngine;

namespace NeoOGL
{


VertexBufferManagerNOBS::VertexBufferManagerNOBS( Device *pkDevice ) :
	VertexBufferManager( pkDevice )
{
}


VertexBufferManagerNOBS::~VertexBufferManagerNOBS()
{
}


VertexBufferPtr VertexBufferManagerNOBS::CreateVertexBuffer( unsigned int uiType, unsigned int uiNumVertices, const VertexDeclaration *pkFormat, const void *pData )
{
	return new VertexBufferGL( m_pkDevice, uiType, uiNumVertices, pkFormat, pData );
}


}; // namespace NeoOGL

