/***************************************************************************
               activator_inl.h  -  Base class for objects with
		     activated/deactivated state attribute
                             -------------------
    begin                : Thu Oct 23 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, activator_inl.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/


inline Activator::Activator( bool bActive ) :
	m_bActive( bActive )
{
}


inline Activator::~Activator()
{
}


inline bool Activator::IsActive() const
{
	return m_bActive;
}


inline void Activator::Activate()
{
	m_bActive = true;
}


inline void Activator::Deactivate()
{
	m_bActive = false;
}


inline bool Activator::Toggle()
{
	if( m_bActive )
		Deactivate();
	else
		Activate();
	
	return m_bActive;
}

