/***************************************************************************
   basetypes.h  -  OS specific includes and defines for standard int types
                             -------------------
    begin                : Sun Jun 15 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, basetypes.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#ifndef __NEBASETYPES_H
#define __NEBASETYPES_H


/**
  * \file basetypes.h
  * Base predefined types of fixed size
  */


#if defined( WIN32 )

#  if defined( _MSC_VER )

     // MSVC++ specific

     typedef unsigned __int64 uint64_t;
     typedef __int64          int64_t;
  
     typedef unsigned int     uint32_t;
     typedef int              int32_t;

     typedef unsigned short   uint16_t;
     typedef short            int16_t;

     typedef unsigned char    uint8_t;
     typedef char             int8_t;

#  elif defined( __MINGW32__ )

     // MinGW (Dev-C++) specific

#    include <stdint.h>

#  else
#    error "Unsupported Win32 environment"
#  endif

#endif // WIN32


#if defined( POSIX )

#  if defined( LINUX )

#    include <stdint.h>

#  elif defined(FREEBSD)

#    include <sys/stdint.h>

#  else
#    error "Unsupported POSIX target"
#  endif

#endif


#if defined( __APPLE__ )

   // MacOS X specific

#  include <stdint.h>

#endif // __APPLE__


#endif

