/***************************************************************************
                     capsule.cpp  -  Capsule bounding volume
                             -------------------
    begin                : Sun Jul 13 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, capsule.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "capsule.h"
#include "aabb.h"
#include "obb.h"
#include "line.h"
#include "plane.h"
#include "contact.h"
#include "vertex.h"
#include "render.h"
#include "renderprimitive.h"

#include <assert.h>

using namespace std;


namespace NeoEngine
{


Capsule::Capsule( float fLength, float fRadius ) :
	BoundingVolume(),
	m_fLength( fLength ),
	m_fRadius( fRadius )
{
}


bool Capsule::Intersection( const Vector3d &rkPoint )
{
	assert( !"Not implemented" );
	return false;
}


bool Capsule::Intersection( const Ray &rkRay, ContactSet *pkContactSet )
{
	assert( !"Not implemented" );
	return false;
}


bool Capsule::Intersection( const Line &rkLine )
{
	assert( !"Not implemented" );
	return false;
}


bool Capsule::Intersection( const Plane &rkPlane )
{
	assert( !"Not implemented" );
	return false;
}


bool Capsule::Intersection( const Vector3d &rkV0, const Vector3d &rkV1, const Vector3d &rkV2, ContactSet *pkContactSet, bool bForceTriNormal, const Vector3d &rkNormal )
{
	assert( !"Not implemented" );
	return false;
}


void Capsule::Generate( AABB *pkAABB )
{
	assert( !"Not implemented" );
}


void Capsule::Generate( OBB *pkOBB )
{
	assert( !"Not implemented" );
}


void Capsule::Generate( Sphere *pkSphere )
{
	assert( !"Not implemented" );
}


void Capsule::Generate( Capsule *pkCapsule )
{
	m_fLength = pkCapsule->m_fLength;
	m_fRadius = pkCapsule->m_fRadius;
}


void Capsule::Generate( VertexBufferPtr &pkVertexBuffer )
{
	assert( !"Not implemented" );
}


void Capsule::Merge( AABB *pkAABB )
{
	assert( !"Not implemented" );
}


void Capsule::Merge( OBB *pkOBB )
{
	assert( !"Not implemented" );
}


void Capsule::Merge( Sphere *pkSphere )
{
	assert( !"Not implemented" );
}


void Capsule::Merge( Capsule *pkCapsule )
{
	assert( !"Not implemented" );
}


void Capsule::RenderOutlines( const Color &rkColor ) const
{
	assert( !"Not implemented" );
}


BoundingVolume *Capsule::Duplicate() const
{
	return new Capsule( *this );
}



}; // namespace NeoEngine
