/***************************************************************************
                          frustum.cpp  -  View frustum
                             -------------------
    begin                : Wed Sep 18 2002
    copyright            : (C) 2002 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, frustum.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2002
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "frustum.h"

#include <assert.h>


namespace NeoEngine
{


Frustum::Frustum() :
	SRTNode()
{
}


bool Frustum::Intersection( const Vector3d &rkPoint )
{
	for( int iPlane = 0; iPlane < 6; ++iPlane )
		if( m_akPlanes[iPlane].Distance( rkPoint ) > 0.0f )
			return false;

	return true;
}


bool Frustum::Intersection( const Line &rkLine )
{
	assert( false );
	return false;
}


bool Frustum::Intersection( const Plane &rkPlane )
{
	assert( false );
	return false;
}


bool Frustum::Intersection( const Vector3d &rkV0, const Vector3d &rkV1, const Vector3d &rkV2, const Vector3d &rkNormal )
{
	assert( false );
	return false;
}


}; // namespace NeoEngine

