/***************************************************************************
                       light.cpp  -  Dynamic lighting
                             -------------------
    begin                : Mon Nov 5 2001
    copyright            : (C) 2001 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, light.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2001
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "light.h"
#include "scenenode.h"

#include "render.h"


namespace NeoEngine
{


Light::Light( LIGHTTYPE eType, int iFlags ) :
	SceneEntity()
{
	m_eType  = eType;
	m_iFlags = iFlags;

	m_fConstantAttenuation  = 1.0f;
	m_fLinearAttenuation    = 0.0f;
	m_fQuadraticAttenuation = 0.0f;

	m_kAmbient.Set(  1.0f, 1.0f, 1.0f );
	m_kDiffuse.Set(  1.0f, 1.0f, 1.0f );
	m_kSpecular.Set( 0.0f, 0.0f, 0.0f );
}


bool Light::Render( Frustum *pkFrustum, bool bForce )
{
	if( SceneEntity::Render( pkFrustum, bForce ) )
	{
		Core::Get()->GetRenderDevice()->AddLight( this );
		return true;
	}

	return false;
}


}; // namespace NeoEngine
