/***************************************************************************
                    renderadapter.h  -  Render adapter data
                             -------------------
    begin                : Tue Oct 28 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, renderadapter.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#ifndef __NERENDERADAPTER_H
#define __NERENDERADAPTER_H


#include "base.h"


/**
  * \file renderadapter.h
  * Render adapter data
  */


namespace NeoEngine
{


/**
  * \brief Device and/or OS specific data for a render adapter
  * \author Mattias Jansson (mattias@realityrift.com)
  */
class NEOENGINE_API RenderAdapter
{
	public:

		/*! User-readable identifier string */
		std::string                                   m_strName;

		/*! Adapter identifier */
		unsigned int                                  m_uiID;

#ifdef WIN32

		/*! Monitor handle (real type [HMONITOR]) */
		void                                         *m_hMonitor;

		/*! Monitor rect, left, top, right, bottom (can be used as RECT) */
		int                                           m_aiMonitorRect[4];

		/*! Padding */
		void                                         *m_apData[13];

#elif defined(__APPLE__)

		/*! Padding */
		void                                         *m_apData[16];

#elif defined(POSIX)

		/*! Padding */
		void                                         *m_apData[16];

#else

		/*! Padding */
		void                                         *m_apData[16];

#endif

};


};


#endif

