/***************************************************************************
              sceneentity.cpp  -  Base class for scene entities
                             -------------------
    begin                : Sat Jan 25 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, sceneentity.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "sceneentity.h"
#include "scenenode.h"
#include "boundingvolume.h"


namespace NeoEngine
{


SceneEntity::~SceneEntity()
{
	delete m_pkBoundingVolume;
}


void SceneEntity::SetBoundingVolume( BoundingVolume *pkBoundingVolume )
{
	delete m_pkBoundingVolume;

	m_pkBoundingVolume = pkBoundingVolume;

	if( m_pkNode )
	{
		//This little hack will cause the node to set the
		//volume update flag, and the GetWorldRotation()
		//will then force an update of world cache SRT,
		//AND set the correct SRT on our new bounding volume
		m_pkNode->NotifyUpdate( false );
		m_pkNode->GetWorldRotation();
	}
}


};
