/***************************************************************************
                        viewport.h  -  Viewport object
                             -------------------
    begin                : Thu Mar 27 2003
    copyright            : (C) 2003 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, viewport.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2003
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/


#ifndef __NEVIEWPORT_H
#define __NEVIEWPORT_H


#include "base.h"



/**
  * \file viewport.h
  * Viewport data
  */


namespace NeoEngine
{


/**
  * \class Viewport
  * \brief Data for a viewport
  * \author Mattias Jansson (mattias@realityrift.com)
  */
class NEOENGINE_API Viewport
{
	public:

		/*! X coordinate */
		int                                           m_iX;

		/*! Y coordinate */
		int                                           m_iY;

		/*! Width */
		int                                           m_iWidth;

		/*! Height */
		int                                           m_iHeight;

		/**
		* Reset data
		*/
		                                              Viewport() : m_iX( 0 ), m_iY( 0 ), m_iWidth( 0 ), m_iHeight( 0 ) {}
};



}; // namespace NeoEngine


#endif // __NEVIEWPORT_H

