/***************************************************************************
                 base.h  -  Base defines for neolua library
                             -------------------
    begin                : Fri Jan 16 2004
    copyright            : (C) 2004 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoLua, base.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2004
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#ifndef __NEOLUA_BASE_H
#define __NEOLUA_BASE_H


#include <neoengine/base.h>


#define NEOLUAVERSION_MAJOR             NEOENGINEVERSION_MAJOR
#define NEOLUAVERSION_MINOR             NEOENGINEVERSION_MINOR
#define NEOLUAVERSION_REVISION          NEOENGINEVERSION_REVISION

#define NEOLUAVERSIONSTRING             NEOENGINEVERSIONSTRING


#ifdef WIN32

#  ifdef _MSC_VER
#    pragma warning( disable : 4231 )
#  endif

#  ifdef BUILD_STATIC

#    define NEOLUA_API
#    define NEOLUAEXPIMP_TEMPLATE

#  else

#    if defined( NEOLUA_EXPORTS )

#      define NEOLUA_API __declspec(dllexport)
#      define NEOLUAEXPIMP_TEMPLATE

#    else

#      define NEOLUA_API __declspec(dllimport)
#      define NEOLUAEXPIMP_TEMPLATE extern

#    endif

#  endif

#  ifdef __cplusplus
	// Instantiate class std::vector<classname> and std::list<classname>
	// This does not create an object. It only forces the generation of all
	// of the members of the class.
	// It exports them from the DLL and imports them into the .exe file.
#    ifdef BUILD_STATIC
#      define NeoLuaUDTVectorEXPIMP(classname)
#    else
#      if( _MSC_VER >= 1300 )
#        define NeoLuaUDTVectorEXPIMP(classname) NEOLUAEXPIMP_TEMPLATE template class NEOLUA_API std::allocator< classname >; NEOLUAEXPIMP_TEMPLATE template class NEOLUA_API std::vector< classname >
#      elif !defined( __MINGW32__ )
#        define NeoLuaUDTVectorEXPIMP(classname) NEOLUAEXPIMP_TEMPLATE template class NEOLUA_API std::vector< classname >
#      else
#        define NeoLuaUDTVectorEXPIMP(classname)
#      endif
#    endif
#  endif

#elif defined(POSIX) || defined(__APPLE__)

#  define NEOLUA_API
#  define NEOLUAEXPIMP_TEMPLATE

#  define NeoLuaUDTVectorEXPIMP(classname)

#else
#  error "Platform uninplemented"
#endif


#endif
