/***************************************************************************
                    bindings.cpp  -  Lua/NeoEngine Bindings
                             -------------------
    begin                : Fri Jan 16 2004
    copyright            : (C) 2004 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoLua, bindings.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2004
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "bindings.h"
#include "script.h"
#include "wtkmsghook.h"

#include <neoengine/base.h>
#include <neoengine/logstream.h>

extern "C"
{

#include <lua/lua.h>
#include <lua/lualib.h>

}

using namespace std;
using namespace NeoEngine;

#include <lua/lunar.h>

#define bindmethod( class, name ) { #name, &class::name }



class lua_neolog
{
	public:
  
		static const char                             className[];
		static Lunar< lua_neolog >::RegType           methods[];

		                                              lua_neolog( lua_State *pkLua ) {}
													 ~lua_neolog() {}

		int                                           Log( lua_State *pkLua ) { neolog << luaL_checkstring( pkLua, 1 ) << endl; return 0; }
		int                                           Level( lua_State *pkLua ) { neolog << luaL_checknumber( pkLua, 1 ); return 0; }
};


const char lua_neolog::className[] = "neolog";

Lunar< lua_neolog >::RegType lua_neolog::methods[] = {
	bindmethod( lua_neolog, Log   ),
	bindmethod( lua_neolog, Level ),
	{ 0, 0 }
};



namespace NeoLua
{


void DefaultBinding::Bind( Script *pkScript )
{
	luaopen_base(   pkScript->m_pkLua );
	luaopen_table(  pkScript->m_pkLua );
	luaopen_io(     pkScript->m_pkLua );
	luaopen_string( pkScript->m_pkLua );
	luaopen_math(   pkScript->m_pkLua );
	luaopen_debug(  pkScript->m_pkLua );

	Lunar< lua_neolog >::Register( pkScript->m_pkLua );
	
#ifdef HAVE_NEOWTK

	Lunar< LuaMsgHookMethod >::Register( pkScript->m_pkLua );

#endif
}


};
