/***************************************************************************
                    console.cpp  -  Lua scriptable console
                             -------------------
    begin                : Sun Jan 18 2004
    copyright            : (C) 2004 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoLua, console.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2004
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "console.h"
#include "script.h"
#include "core.h"

#include <neoengine/strutil.h>

using namespace std;
using namespace NeoEngine;


namespace NeoLua
{


LuaConsole::LuaConsole( unsigned int uiHistory ) :
	Console( uiHistory ),
	m_pkScript( Core::Get()->CreateScript() )
{
}


LuaConsole::~LuaConsole()
{
	delete m_pkScript;
}


bool LuaConsole::ProcessCmd( const std::string &rstrCmd )
{
	ConsoleCmdCallback *pkDefault = m_pkDefaultCallback;

	m_pkDefaultCallback = 0;

	if( Console::ProcessCmd( rstrCmd ) )
		return true;

	bool bProcessed = false;

	//Process as Lua script method

	m_pkDefaultCallback = pkDefault;

	if( !bProcessed && m_pkDefaultCallback )
	{
		//Split on first space
		string strCmd = Strip( rstrCmd );
		string strArgs;
		
		unsigned int iFirst = strCmd.find( ' ' );
		
		if( iFirst != string::npos )
		{
			strArgs = strCmd.substr( iFirst + 1 );
			strCmd  = strCmd.substr( 0, iFirst );
		}

		m_pkDefaultCallback->ConsoleCmd( strCmd, strArgs );
	}

	return true;
}


};
