/***************************************************************************
                       script.h  -  Lua script object
                             -------------------
    begin                : Fri Jan 16 2004
    copyright            : (C) 2004 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoLua, script.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2004
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "script.h"

#include <neoengine/file.h>
#include <neoengine/logstream.h>

extern "C"
{

#include "lua/lua.h"
#include "lua/lauxlib.h"

}

using namespace std;
using namespace NeoEngine;


namespace NeoLua
{


Script::Script() :
	LoadableEntity(),
	m_pkLua( lua_open() )
{
}


Script::~Script()
{
}


bool Script::LoadNode( unsigned int uiFlags )
{
	unsigned int uiSize = m_pkFile->GetSize();
	char *pszBuffer = new char[ uiSize + 1 ];
	int iRet = 0;

	m_pkFile->Read( pszBuffer, uiSize );

	pszBuffer[ uiSize ] = 0;

	if( ( iRet = luaL_loadbuffer( m_pkLua, pszBuffer, uiSize, m_pkFile->GetName().c_str() ) ) != 0 )
		neolog << LogLevel( ERROR ) << "*** Unable to load script file [" << m_pkFile->GetName() << "]: loadbuffer returned error [" << iRet << "]" << endl
		       << pszBuffer << endl;

	lua_pcall( m_pkLua, 0, 0, 0 );

	delete [] pszBuffer;

	return( iRet == 0 );
}


};

