/***************************************************************************
                       script.h  -  Lua script object
                             -------------------
    begin                : Fri Jan 16 2004
    copyright            : (C) 2004 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoLua, script.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2004
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#ifndef __NEOLUA_SCRIPT_H
#define __NEOLUA_SCRIPT_H

#include "base.h"

#include <neoengine/loadableentity.h>


extern "C" { struct lua_State; }


namespace NeoLua
{


class NEOLUA_API Script : public NeoEngine::LoadableEntity
{
	friend class Core;

	protected:

		/**
		*/
		                                              Script();


		/**
		* Load script from file
		* \param uiFlags                              Loading flags set by caller
		*/
		virtual bool                                  LoadNode( unsigned int uiFlags );


	public:

		lua_State                                    *m_pkLua;


		/**
		*/
		virtual                                      ~Script();
};


};


#endif
