/***************************************************************************
                 base.h  -  Base defines for network API
                             -------------------
    begin                : Mon Jun 21 2004
    copyright            : (C) 2004 by emedia-solutions wolf
    email                : markus@emedia-solutions-wolf.de
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoNET, base.h

 The Initial Developer of the Original Code is Markus Wolf.
 Portions created by Markus Wolf are Copyright (C) 2004
 emedia-solutions wolf. All Rights Reserved.

 ***************************************************************************/

#ifndef __NEONETBASE_H
#define __NEONETBASE_H

#ifndef NOGDI
#  define NOGDI
#endif

#include <neoengine/base.h>


#define NEONETVERSION_MAJOR             NEOENGINEVERSION_MAJOR
#define NEONETVERSION_MINOR             NEOENGINEVERSION_MINOR
#define NEONETVERSION_REVISION          NEOENGINEVERSION_REVISION

#define NEONETVERSIONSTRING             NEOENGINEVERSIONSTRING


#ifdef WIN32

#  ifdef BUILD_STATIC
#    define NEONET_API
#    define NEONETEXPIMP_TEMPLATE
#  else
#    ifdef NEONET_EXPORTS
#      define NEONET_API __declspec(dllexport)
#      define NEONETEXPIMP_TEMPLATE
#    else
       //disable warnings on non-standard extension bullshit
#      ifdef _MSC_VER
#        pragma warning( disable : 4231 )
#      endif
#      define NEONET_API __declspec(dllimport)
#      define NEONETEXPIMP_TEMPLATE extern
#    endif
#  endif

#  define NEONET_ATTRIBUTE_PACKED

#  ifdef __cplusplus
	// Instantiate class std::vector<classname> and std::list<classname>
	// This does not create an object. It only forces the generation of all
	// of the members of the class.
	// It exports them from the DLL and imports them into the .exe file.

	//disable warnings on non-standard extension bullshit
#    ifdef BUILD_STATIC
#      define NetUDTVectorEXPIMP(classname)
#    else
#      ifdef _MSC_VER
#        pragma warning( disable : 4231 )
#      endif
#      if ( _MSC_VER >= 1300 )
#        define NetUDTVectorEXPIMP(classname) NEONETEXPIMP_TEMPLATE template class NEONET_API std::allocator< classname >; NEONETEXPIMP_TEMPLATE template class NEONET_API std::vector< classname >
#      elif !defined( __MINGW32__ )
#        define NetUDTVectorEXPIMP(classname) NEONETEXPIMP_TEMPLATE template class NEONET_API std::vector< classname >
#      else
#        define NetUDTVectorEXPIMP(classname)
#      endif
#    endif
#  endif

#elif defined(POSIX) || defined(__APPLE__)

#  include <stdint.h>
#  define NEONET_API
#  define NEONET_ATTRIBUTE_PACKED __attribute__((packed))

#else
#  error "Platform uninplemented"
#endif


#endif
