/***************************************************************************
              message.cpp  -  Abstract base class for all messages
                             -------------------
    begin                : Mon Jun 22 2004
    copyright            : (C) 2004 by Markus Wolf
    email                : markus@emedia-solutions-wolf.de
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoNET, message.h

 The Initial Developer of the Original Code is Markus Wolf.
 Portions created by Markus Wolf are Copyright (C) 2004
 emedia-solutions wolf. All Rights Reserved.

 ***************************************************************************/
#include "message.h"

#include <neoengine/logstream.h>

#include <string>

using namespace std;

namespace NeoNET {

Message::Message( unsigned int uiMessageID, unsigned int uiMessageLength ) :
	m_uiMessageID( uiMessageID ),
	m_uiMessageLength( uiMessageLength )
{
}

Message::~Message()
{
}

std::string Message::SerializeHeader()
{
	string strID;
	string strLength;

	for ( unsigned int i = 0; i < sizeof( unsigned int ); i++ )
	{
		strID += ( ( char* )&m_uiMessageID )[ i ];
		strLength += ( ( char* )&m_uiMessageLength )[ i ];
	}
	
	return strID + strLength;
}

};
