/***************************************************************************
                  attribute.cpp  -  Abstraction of object data
                             -------------------
    begin                : Tue Dec 17 2002
    copyright            : (C) 2002 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoWTK, attribute.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2002
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "attribute.h"



#ifdef HAVE_NEOCHUNKIO

#include "coord.h"

#include <neoengine/logstream.h>

#include <neochunkio/stdstring.h>
#include <neochunkio/bool.h>

using namespace std;
using namespace NeoEngine;
using namespace NeoChunkIO;


namespace NeoWTK
{


AttributeChunk::~AttributeChunk()
{
	delete m_pkData;
}


int AttributeChunk::ParseData( unsigned int uiFlags, FileManager *pkFileManager )
{
	string   strName;
	Chunk   *pkChunk = 0;

	if( ( pkChunk = FindChunk( "name", NeoChunkIO::ChunkType::STRING, -1 ) ) )
		strName = dynamic_cast< StringChunk* >( pkChunk )->m_strData;

	if( ( pkChunk = FindChunk( "data", 0, -1 ) ) )
	{
		CoordChunk *pkCoordChunk  = 0;
		StringChunk   *pkStringChunk = 0;
		BoolChunk     *pkBoolChunk   = 0;

		if( ( pkCoordChunk = dynamic_cast< CoordChunk* >( pkChunk ) ) )
			m_pkData = new Attribute< Coord >( strName, pkCoordChunk->m_kCoord );
		else if( ( pkStringChunk = dynamic_cast< StringChunk* >( pkChunk ) ) )
			m_pkData = new Attribute< string >( strName, pkStringChunk->m_strData );
		else if( ( pkBoolChunk = dynamic_cast< BoolChunk* >( pkChunk ) ) )
			m_pkData = new Attribute< bool >( strName, pkBoolChunk->m_bData );
		else
		{
			neolog << LogLevel( WARNING ) << "[AttributeChunk::ParseData] invalid data type" << endl;
			return 0;
		}
	}
	else
	{
		neolog << LogLevel( WARNING ) << "[AttributeChunk::ParseData] no data" << endl;
		return 0;
	}

	return 1;
}


}; /*! namespace NeoWTK */


#endif


