/***************************************************************************
                 base.h  -  Base defines for windowing toolkit
                             -------------------
    begin                : Sun Nov 17 2002
    copyright            : (C) 2002 by Reality Rift Studios
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoWTK, base.h

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2002
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#ifndef __NEOWTKBASE_H
#define __NEOWTKBASE_H

#ifndef NOGDI
#  define NOGDI
#endif

#include <neoengine/base.h>


#define NEOWTKVERSION_MAJOR             NEOENGINEVERSION_MAJOR
#define NEOWTKVERSION_MINOR             NEOENGINEVERSION_MINOR
#define NEOWTKVERSION_REVISION          NEOENGINEVERSION_REVISION

#define NEOWTKVERSIONSTRING             NEOENGINEVERSIONSTRING


#ifdef WIN32

#  ifdef BUILD_STATIC
#    define NEOWTK_API
#    define NEOWTKEXPIMP_TEMPLATE
#  else
#    ifdef NEOWTK_EXPORTS
#      define NEOWTK_API __declspec(dllexport)
#      define NEOWTKEXPIMP_TEMPLATE
#    else
       //disable warnings on non-standard extension bullshit
#      ifdef _MSC_VER
#        pragma warning( disable : 4231 )
#      endif
#      define NEOWTK_API __declspec(dllimport)
#      define NEOWTKEXPIMP_TEMPLATE extern
#    endif
#  endif

#  define NEOWTK_ATTRIBUTE_PACKED

#  ifdef __cplusplus
	// Instantiate class std::vector<classname> and std::list<classname>
	// This does not create an object. It only forces the generation of all
	// of the members of the class.
	// It exports them from the DLL and imports them into the .exe file.

	//disable warnings on non-standard extension bullshit
#    ifdef BUILD_STATIC
#      define WtkUDTVectorEXPIMP(classname)
#    else
#      ifdef _MSC_VER
#        pragma warning( disable : 4231 )
#      endif
#      if ( _MSC_VER >= 1300 )
#        define WtkUDTVectorEXPIMP(classname) NEOWTKEXPIMP_TEMPLATE template class NEOWTK_API std::allocator< classname >; NEOWTKEXPIMP_TEMPLATE template class NEOWTK_API std::vector< classname >
#      elif !defined( __MINGW32__ )
#        define WtkUDTVectorEXPIMP(classname) NEOWTKEXPIMP_TEMPLATE template class NEOWTK_API std::vector< classname >
#      else
#        define WtkUDTVectorEXPIMP(classname)
#      endif
#    endif
#  endif

#elif defined(POSIX) || defined(__APPLE__)

#  include <stdint.h>
#  define NEOWTK_API
#  define NEOWTK_ATTRIBUTE_PACKED __attribute__((packed))

#else
#  error "Platform uninplemented"
#endif


#endif
