/***************************************************************************
                    msg.cpp  -  Window toolkit message class
                             -------------------
    begin                : Sun Nov 17 2002
    copyright            : (C) 2002 by Mattias Jansson
    email                : mattias@realityrift.com
 ***************************************************************************

 The contents of this file are subject to the Mozilla Public License Version
 1.1 (the "License"); you may not use this file except in compliance with
 the License. You may obtain a copy of the License at 
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS" basis,
 WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 for the specific language governing rights and limitations under the
 License.

 The Original Code is the NeoEngine, NeoWTK, msg.cpp

 The Initial Developer of the Original Code is Mattias Jansson.
 Portions created by Mattias Jansson are Copyright (C) 2002
 Reality Rift Studios. All Rights Reserved.

 ***************************************************************************/

#include "msg.h"

using namespace std;


namespace NeoWTK
{


string Msg::GetIDAsString() const
{
	switch( m_eID )
	{
		case INVALID:
			return "Invalid";

		case RESIZE:
			return "Resize";

		case MOVE:
			return "Move";

		case MOUSE_ENTER:
			return "MouseEnter";

		case MOUSE_LEAVE:
			return "MouseLeave";

		case MOUSE_DOWN:
			return "MouseDown";

		case MOUSE_UP:
			return "MouseUp";

		case MOUSE_MOVE:
			return "MouseMove";

		case BUTTON_DOWN:
			return "ButtonDown";

		case BUTTON_UP:
			return "ButtonUp";

		default:
			break;
	}
	
	return "Unknown";
}


}; /*! namespace NeWTK */

